// vim:syntax=ragel

#include <stdio.h>
#include "global.h"

// p_wchar2 is INT32
#if defined(HAVE_WCHAR_H) && 4 == SIZEOF_WCHAR_T
# define USE_WCHAR_SCANF
#endif

#ifdef USE_WCHAR_SCANF
# include <wchar.h>
#endif


%%{
    machine JSON_number;
    alphtype int;
    # we could be much less specific here.. but i guess its ok to ensure the 
    # format, not correctness in the sense of sscanf 
    # 
    action break {
		fbreak;
    }

    myspace = [ \n\r\t];
    end = [\]},:]|myspace;
    exp = [eE] >{d = 1;}. [+\-]? . digit+ . (end >break)?;
    float = '.' >{d = 1;} . digit+ . (end >break | exp)?;
    main := '-' ? . (('0' | ([1-9] . digit*)) . (end >break | float | exp)?) | float; 
}%%

static p_wchar2 *_parse_JSON_number(p_wchar2 *p, p_wchar2 *pe, struct parser_state *state) {
    p_wchar2 *i = p;
    int cs;
    INT_TYPE d = 0;
    FLOAT_TYPE f;

    %% write data;

    %% write init;
    %% write exec;

    if (cs >= JSON_number_first_final) {
	
		if (!state->validate) {
#ifdef USE_WCHAR_SCANF
			p_wchar2 temp = *p;
			*p = 0;

			if (d) {
				if (1 != swscanf((wchar_t*)i, L"%"PRINTPIKEFLOAT"f", &f)) {
					*p = temp;
					push_int((INT_TYPE)i);
					return NULL;
				}
				push_float(f);
			} else {
				if (1 != swscanf((wchar_t*)i, L"%"PRINTPIKEINT"d", &d)) {
					*p = temp;
					push_int((INT_TYPE)i);
					return NULL;
				}
				push_int(d);
			}

			*p = temp;
#else
			ptrdiff_t len = (ptrdiff_t)(p - i); 

			char *temp = (char*)malloc(len+1);

			if (temp == NULL) {
				push_int((INT_TYPE)p);
				return NULL;
			}

			*(temp + len) = '\0';
			
			do {
				*(temp + len) = (char)(*(i + len));
			} while(len-- > 0);

			if (d == 1) {
				if (1 != sscanf(temp, "%"PRINTPIKEFLOAT"f", &f)) {
					free(temp);

					push_int((INT_TYPE)i);
					return NULL;
				}
				push_float(f);
			} else {
				if (1 != sscanf(temp, "%"PRINTPIKEINT"d", &d)) {
					free(temp);

					push_int((INT_TYPE)i);
					return NULL;
				}
				push_int(d);
			}

			free(temp);
#endif
		}

		return p;
    }

    push_int((INT_TYPE)p);
    return NULL;
}

