// vim:syntax=ragel

#include <stdio.h>
#include "config.h"
#include "machine.h"
#include "global.h"

%%{
    machine JSON_number;
    alphtype char;
    # we could be much less specific here.. but i guess its ok to ensure the 
    # format, not correctness in the sense of sscanf 
    # 
    action break {
	fbreak;
    }

    myspace = [ \n\r\t];
    end = [\]},:]|myspace;
    exp = [eE] >{d = 1;}. [+\-]? . digit+ . (end >break)?;
    float = '.' >{d = 1;} . digit+ . (end >break | exp)?;
    main := '-' ? . (('0' | ([1-9] . digit*)) . (end >break | float | exp)?) | float; 
}%%

static char *_parse_JSON_number_utf8(char *p, char *pe, struct parser_state *state) {
    char *i = p;
    int cs;
    INT_TYPE d = 0;
    FLOAT_TYPE f;

    %% write data;

    %% write init;
    %% write exec;

    if (cs >= JSON_number_first_final) {
	
		if (!state->validate) {
			char temp = *p;
			*p = 0;

			if (d) {
				if (1 != sscanf(i, "%"PRINTPIKEFLOAT"f", &f)) {
					*p = temp;

					push_int((INT_TYPE)i);
					return NULL;
				}
				push_float(f);
			} else {
				if (1 != sscanf(i, "%"PRINTPIKEINT"d", &d)) {
					*p = temp;

					push_int((INT_TYPE)i);
					return NULL;
				}
				push_int(d);
			}

			*p = temp;
		}

		return p;
    }

    push_int((INT_TYPE)p);
    return NULL;
}

